/*
 * list processor module program copyright (C) 2009 - 2013 H.Niwa
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef __LISP_H__

extern int Car(Context* cx, Node* goalscar, List* module);
extern int Cdr(Context* cx, Node* goalscar, List* module);
extern int Cons(Context* cx, Node* goalscar, List* module);
extern int Nth(Context* cx, Node* goalscar, List* module);
extern int SetNth(Context* cx, Node* goalscar, List* module);

extern int Caar(Context* cx, Node* goalscar, List* module);
extern int Cadr(Context* cx, Node* goalscar, List* module);
extern int Cdar(Context* cx, Node* goalscar, List* module);
extern int Cddr(Context* cx, Node* goalscar, List* module);

extern int Caaar(Context* cx, Node* goalscar, List* module);
extern int Caadr(Context* cx, Node* goalscar, List* module);
extern int Cadar(Context* cx, Node* goalscar, List* module);
extern int Caddr(Context* cx, Node* goalscar, List* module);
extern int Cdaar(Context* cx, Node* goalscar, List* module);
extern int Cdadr(Context* cx, Node* goalscar, List* module);
extern int Cddar(Context* cx, Node* goalscar, List* module);
extern int Cdddr(Context* cx, Node* goalscar, List* module);

extern int Caaaar(Context* cx, Node* goalscar, List* module);
extern int Caaadr(Context* cx, Node* goalscar, List* module);
extern int Caadar(Context* cx, Node* goalscar, List* module);
extern int Caaddr(Context* cx, Node* goalscar, List* module);
extern int Cadaar(Context* cx, Node* goalscar, List* module);
extern int Cadadr(Context* cx, Node* goalscar, List* module);
extern int Caddar(Context* cx, Node* goalscar, List* module);
extern int Cadddr(Context* cx, Node* goalscar, List* module);
extern int Cdaaar(Context* cx, Node* goalscar, List* module);
extern int Cdaadr(Context* cx, Node* goalscar, List* module);
extern int Cdadar(Context* cx, Node* goalscar, List* module);
extern int Cdaddr(Context* cx, Node* goalscar, List* module);
extern int Cddaar(Context* cx, Node* goalscar, List* module);
extern int Cddadr(Context* cx, Node* goalscar, List* module);
extern int Cdddar(Context* cx, Node* goalscar, List* module);
extern int Cddddr(Context* cx, Node* goalscar, List* module);


#endif
